# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import usermsg
import vecmath
import gamethread

import os

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


g_informations = es.AddonInfo()
g_informations["name"] = "Daggers by L'In20Cible"
g_informations["version"] = "1.0"
g_informations["date"] = "2010-07-02"
g_informations["author"] = "L\'in20Cible"
g_informations["basename"] = "daggers"

es.ServerVar((g_informations["basename"] + "_version"), (g_informations["version"] + " by " + g_informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


g_options = {
   "enable"  : [1  , "daggers_enable <1/0> -- Active/Désactive les fonctionnalités du script Daggers."],
   "distance": [750, "dagger_distance <1/0> -- Définit la distance du lancé."]
   }
for option in g_options:
   g_options[option] = es.ServerVar((g_informations["basename"] + "_" + option), g_options[option][0], g_options[option][1])


# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   __init__()
   es.addons.registerClientCommandFilter(ClientCommandFilterCallBack)
   
   
def __init__():
   filepath = os.path.join(str(es.ServerVar("eventscripts_gamedir")), "cfg", "eventscripts", g_informations["basename"], "configuration.cfg").replace(os.sep, "/")
   if os.path.isfile(filepath):
      es.mexec(filepath.replace(str(es.ServerVar("eventscripts_gamedir")).replace(os.sep, "/"), ".."))
      
      
def unload():
   es.addons.unregisterClientCommandFilter(ClientCommandFilterCallBack)
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetPlayerWeaponIndex(userid, weapon):
   returnvalue = 0
   if not es.exists("userid", userid):
      return returnvalue
   for index in es.createentitylist(weapon):
      if (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != es.getplayerhandle(userid)):
         continue
      returnvalue = index
   return returnvalue
   
   
def ExecutePlayerCheat(userid, string):
   if int(es.ServerVar("sv_cheats")):
      es.sexec(userid, string)
   else:
      es.forcevalue("sv_cheats", 1)
      es.sexec(userid, string)
      es.forcevalue("sv_cheats", 0)
      
      
def GetPlayerViewCoord(userid):
   returnvalue = "0,0,0"
   entities = es.createentitylist("prop_dynamic")
   ExecutePlayerCheat(userid, "prop_dynamic_create props_c17/tv_monitor01_screen.mdl")
   for index in es.createentitylist("prop_dynamic"):
      if (index in entities):
         continue
      returnvalue = es.getindexprop(index, "CBaseEntity.m_vecOrigin")
      es.remove(index)
   return returnvalue
   
   
def GetPlayerEyeCoord(userid):
   returnvalue = "0,0,0"
   x, y, z = es.getplayerlocation(userid)
   z = (z + 66.7)
   if (es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2):
      z = (z - 16.1)
   return es.createvectorstring(x, y, z)
   
   
def GetPlayerViewProp(userid):
   returnvalue = 0
   ExecutePlayerCheat(userid, "ent_setname viewed_prop")
   for index in es.createentitylist():
      if (es.entitygetvalue(index, "targetname") != "viewed_prop"):
         continue
      returnvalue = index
      es.entitysetvalue(index, "targetname", "")
   return returnvalue
   
   
def GetPlayerViewPlayer(userid):
   returnvalue = 0
   index = GetPlayerViewProp(userid)
   players = es.createplayerlist()
   for player in players:
      if (players[player]["index"] != index):
         continue
      returnvalue = player
   return returnvalue
   
   
def CreateWeaponKnife(index):
   origin = es.getindexprop(index, "CBaseEntity.m_vecOrigin")
   angles = es.getindexprop(index, "CBaseEntity.m_angRotation")
   es.remove(index)
   index = es.createentity("weapon_knife")
   offsets = {
      "origin": origin.replace(",", " "),
      "angles": angles.replace(",", " ")
      }
   for offset in offsets:
      es.entitysetvalue(index, offset, offsets[offset])
   es.spawnentity(index)
   
   
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def ClientCommandFilterCallBack(userid, arguments):
   if int(g_options["enable"]) and (arguments[0].lower() == "drop") and not es.getplayerprop(userid, "CBasePlayer.pl.deadflag") and (es.createplayerlist(userid)[userid]["weapon"] == "weapon_knife"):
      returnvalue = False
      es.cexec(userid, "lastinv")
      es.remove(GetPlayerWeaponIndex(userid, "weapon_knife"))
      origin = GetPlayerEyeCoord(userid)
      target = GetPlayerViewPlayer(userid)
      vector = vecmath.vector(es.createvectorfrompoints(origin, GetPlayerViewCoord(userid))) * int(g_options["distance"])
      if target and (vecmath.distance(origin, GetPlayerEyeCoord(target)) < int(g_options["distance"])):
         es.delayed(0.1, "damage %i %i 32 %i" % (target, es.getplayerprop(target, "CBasePlayer.m_iHealth"), userid))
      index = es.createentity("prop_physics_override")
      offsets = {
         "origin"    : origin.replace(",", " "),
         "model"     : "models/weapons/w_knife_t.mdl",
         "classname" : "prop_physics_multiplayer",
         "angles"    : es.createvectorstring(45, es.getplayerprop(userid, "CCSPlayer.m_angEyeAngles[1]"), 0.0).replace(",", " "),
         "targetname": "dagger_%i" % index
         }
      for offset in offsets:
         es.entitysetvalue(index, offset, offsets[offset])
      es.setindexprop(index, "CBaseEntity.m_CollisionGroup", 2)
      es.spawnentity(index)
      gamethread.delayed(0.05, es.setindexprop, (index, "CBaseEntity.m_CollisionGroup", 0))
      es.fire(userid, "dagger_%i" % index, "wake")
      es.delayed(0, "es_xphysics active setvelocity %i %s" % (index, vector))
      gamethread.delayed(0.5, CreateWeaponKnife, index)
   return True
   
   
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   __init__()